<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Noolefunktsioonid</title>
    <link rel="stylesheet" href="harjutused-js.css">
    <script src="accounts.js"></script>
</head>

<body>
    <div class="ex">
        <h2>Harjutus 1</h2>
        <p>
            Leia klient konto numbriga EE154770478
        </p>
        <div id="result1" class="ex-result">
        </div>
        <script>
            // Harjutus 1
            // ------------------------------------
            // Sinu kood siia....
            const result1 = accounts.find(c => c.number === 'EE154770478');

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 2</h2>
        <p>
            Leia klient konto numbriga LT937416401
        </p>
        <div id="result2" class="ex-result">
        </div>
        <script>
            // Harjutus 2
            // ------------------------------------
            // Sinu kood siia....
            const result2 = accounts.find(c => c.number === 'LT937416401');

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 3</h2>
        <p>
            Leia klient konto numbriga LV587816561
        </p>
        <div id="result3" class="ex-result">
        </div>
        <script>
            // Harjutus 3
            // ------------------------------------
            // Sinu kood siia....
            const result3 = accounts.find(x => x.number === 'LV587816561');

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 4</h2>
        <p>
            Leia klient eesnimega 'Angelina'
        </p>
        <div id="result4" class="ex-result">
        </div>
        <script>
            // Harjutus 4
            // ------------------------------------
            // Sinu kood siia....
            const result4 = accounts.find(c => c.firstName === 'Angelina');


            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 5</h2>
        <p>
            Leia kõik kliendid, kellel on kontol rohkem kui 500 eurot.
        </p>
        <div id="result5" class="ex-result">
        </div>
        <script>
            // Harjutus 5
            // ------------------------------------
            // Sinu kood siia....
            const result5 = accounts.filter(a => a.balance > 500);

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 6</h2>
        <p>
            Leia kõik kliendid, kellel on kontol rohkem kui 1000 eurot.
        </p>
        <div id="result6" class="ex-result">
        </div>
        <script>
            // Harjutus 6
            // ------------------------------------
            // Sinu kood siia....
            const result6 = accounts.filter(a => a.balance > 1000);


            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 7</h2>
        <p>
            Leia kõik leedukad.
        </p>
        <div id="result7" class="ex-result">
        </div>
        <script>
            // Harjutus 7
            // ------------------------------------
            // Sinu kood siia.... // .substr() .startsWith('LT')
            const result7 = accounts.filter(c => c.number.substr(0, 2) === 'LT');


            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 8</h2>
        <p>
            Leia kõik lätlased, kellel on kontol alla 100 euro.
        </p>
        <div id="result8" class="ex-result">
        </div>
        <script>
            // Harjutus 8
            // ------------------------------------
            // Sinu kood siia....
            // const result8 = accounts
            // .filter(a => a.number.startsWith('LV'))
            // .filter(x => x.balance < 100)

            const result8 = accounts
                .filter(t => t.number.startsWith('LV') && t.balance < 100)

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 9</h2>
        <p>
            Leia kõik kõige rikkam klient.
        </p>
        <div id="result9" class="ex-result">
        </div>
        <script>
            // Harjutus 9
            // ------------------------------------
            // Sinu kood siia....
            const result9 = accounts
                .sort((a1, a2) => a2.balance - a1.balance)
                .find(c => !!c) // tagasta esimene

            // tagastab > 0 ==> keera ümber (not OK)
            // tagastab 0 või < 0 ==> ära puutu (OK)
            // Näide
            // persons.sort((p1, p2) => p1.age - p2.age);


            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 10</h2>
        <p>
            Leia kõigi nende klientide kontojääkide summa, kellel on kontol vähemalt 1000 eurot.
        </p>
        <div id="result10" class="ex-result">
        </div>
        <script>
            // Harjutus 10
            // ------------------------------------
            // Sinu kood siia....

            let ritchCustomers = accounts.filter(a => a.balance >= 1000)
            let sum = 0
            ritchCustomers.forEach(c => sum = sum + c.balance)

            const result10 = sum;

            // leiakirjed ja kasuta funktsiooni .foreach() ja välist muutujat

            // ------------------------------------
        </script>
    </div>

    <div class="ex">
        <h2>Harjutus 11</h2>
        <p>
            Leia kõigi Eesti klientide kontojääkide summa.
        </p>
        <div id="result11" class="ex-result">
        </div>
        <script>
            // Harjutus 11
            // ------------------------------------
            // Sinu kood siia....
            const result11 = undefined;


            // ------------------------------------
        </script>
    </div>

    <script>
        function toCustomerString(customer) {
            if (!customer) {
                return '-';
            }
            return `Eesnimi: ${customer.firstName}<br>
                    Perenimi: ${customer.lastName}<br>
                    Sugu: ${customer.gender}<br>
                    Konto number: ${customer.number}<br>
                    Konto jääk: ${customer.balance}<br><br>`;
        }

        function displayResult(boxId, result) {
            const resultBox = document.querySelector(`#${boxId}`);
            if (Array.isArray(result)) {
                resultBox.innerHTML = `<strong>Leitud: ${result.length}</strong><br><br>`
                    + result.map(toCustomerString).join('');
            } else if (Number.isInteger(result)) {
                resultBox.innerHTML = result;
            } else {
                resultBox.innerHTML = toCustomerString(result);
            }
        }

        displayResult('result1', result1);
        displayResult('result2', result2);
        displayResult('result3', result3);
        displayResult('result4', result4);
        displayResult('result5', result5);
        displayResult('result6', result6);
        displayResult('result7', result7);
        displayResult('result8', result8);
        displayResult('result9', result9);
        displayResult('result10', result10);
        displayResult('result11', result11);
    </script>
</body>

</html>